(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngxui-datatable', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory(global['ngxui-datatable'] = {}, global.ng.core, global.ng.common));
}(this, function (exports, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxuiDatatableService = /** @class */ (function () {
        function NgxuiDatatableService() {
        }
        NgxuiDatatableService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxuiDatatableService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxuiDatatableService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgxuiDatatableService_Factory() { return new NgxuiDatatableService(); }, token: NgxuiDatatableService, providedIn: "root" });
        return NgxuiDatatableService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxuiDatatableComponent = /** @class */ (function () {
        function NgxuiDatatableComponent() {
            this.clickEvent = new core.EventEmitter();
            this.order = true;
            this.currentSortKey = '';
            this.context = {};
        }
        Object.defineProperty(NgxuiDatatableComponent.prototype, "headers", {
            get: /**
             * @return {?}
             */
            function () { return this.config.filter((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.schema !== false; })); },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgxuiDatatableComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            console.log(this.data);
            console.log(this.config);
        };
        /**
         * @param {?} array
         * @return {?}
         */
        NgxuiDatatableComponent.prototype.checkOrder = /**
         * @param {?} array
         * @return {?}
         */
        function (array) {
            if (!this.order) {
                array.reverse();
            }
            return array;
        };
        /**
         * @param {?} key
         * @return {?}
         */
        NgxuiDatatableComponent.prototype.sort = /**
         * @param {?} key
         * @return {?}
         */
        function (key) {
            /** @type {?} */
            var dataClone = __spread(this.data);
            dataClone.sort((/**
             * @param {?} x
             * @param {?} y
             * @return {?}
             */
            function (x, y) { return (x[key] > y[key]) ? 1 : -1; }));
            this.data = __spread(this.checkOrder(dataClone));
        };
        /**
         * @param {?} header
         * @return {?}
         */
        NgxuiDatatableComponent.prototype.sortBy = /**
         * @param {?} header
         * @return {?}
         */
        function (header) {
            if (header === this.currentSortKey) {
                this.order = !this.order;
            }
            this.currentSortKey = header;
            this.sort(header);
        };
        /**
         * @param {?} name
         * @return {?}
         */
        NgxuiDatatableComponent.prototype.sortedBy = /**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            console.log(this.currentSortKey === name || false);
        };
        /**
         * @param {?} name
         * @return {?}
         */
        NgxuiDatatableComponent.prototype.sortHandler = /**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            this.sortBy(name);
        };
        /**
         * @param {?} eventKey
         * @param {?} eventObject
         * @return {?}
         */
        NgxuiDatatableComponent.prototype.emitActionEvent = /**
         * @param {?} eventKey
         * @param {?} eventObject
         * @return {?}
         */
        function (eventKey, eventObject) {
            /** @type {?} */
            var event = {
                key: eventKey,
                object: eventObject
            };
            this.clickEvent.emit(event);
        };
        NgxuiDatatableComponent.decorators = [
            { type: core.Component, args: [{
                        // tslint:disable-next-line: component-selector
                        selector: 'ngxui-datatable',
                        template: "<table class=\"ngxui-datatable\">\n    <thead class=\"ngxui-datatable__header\">\n        <tr class=\"ngxui-datatable__tr\">\n            <ng-container *ngFor=\"let header of headers\">\n                <lib-table-header [name]=\"header.name\" [sortKey]=\"currentSortKey\" (emitSortClick)=\"sortHandler($event)\">\n                </lib-table-header>\n            </ng-container>\n\n            <ng-container *ngFor=\"let action of actions.items\">\n                <lib-table-header [name]=\"action.name\" [sortKey]=\"currentSortKey\" (emitSortClick)=\"sortHandler($event)\">\n                </lib-table-header>\n            </ng-container>\n\n        </tr>\n    </thead>\n    <tbody class=\"ngxui-datatable__body\">\n        <tr class=\"ngxui-datatable__tr\" *ngFor=\"let row of data\">\n            <ng-container *ngFor=\"let header of headers\">\n                <td class=\"ngxui-datatable__td\">\n                    <ng-container *ngIf=\"header.link; else second\">\n                        <a href=\"{{ row[header.name] }}\">Link</a>\n                    </ng-container>\n                    <ng-template #second>{{ row[header.name] }}</ng-template>\n                </td>\n            </ng-container>\n            <td class=\"ngxui-datatable__td ngxui-datatable__actions\" *ngIf=\"actions\">\n                <button class=\"ngxui-datatable__button\" (click)=\"emitActionEvent(action.key, row)\"\n                    *ngFor=\"let action of actions.items\">{{ action.name }}</button>\n            </td>\n        </tr>\n    </tbody>\n</table>\n",
                        styles: ["@charset \"UTF-8\";:host ::ng-deep .ngxui-datatable{position:relative;width:100%;border-collapse:collapse;overflow:hidden;word-break:normal;word-break:keep-all;color:#53545a;border:1px solid #dddee4;font-size:14px}:host ::ng-deep .ngxui-datatable__header{text-transform:uppercase;text-align:left;font-weight:600;background-color:#4d4d4d;color:#fff;border-top:1px solid #dddee4;box-shadow:0 0 5px 0 rgba(128,128,128,.15);margin:1rem 0}:host ::ng-deep .ngxui-datatable__td,:host ::ng-deep .ngxui-datatable__th{position:relative}:host ::ng-deep .ngxui-datatable__tr{background-color:transparent;border-bottom:1px solid #dddee4}:host ::ng-deep .ngxui-datatable__th{border:1px solid rgba(0,0,0,.12);padding:1rem .75rem}:host ::ng-deep .ngxui-datatable__th:after{content:\"\u25BF\";position:absolute;right:2rem;top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%)}:host ::ng-deep .ngxui-datatable__td{border:1px solid rgba(0,0,0,.12);padding:.5rem}:host ::ng-deep .ngxui-datatable__button{padding:.25rem;background-color:coral;border-color:#ff6c37;color:#fff}"]
                    }] }
        ];
        /** @nocollapse */
        NgxuiDatatableComponent.ctorParameters = function () { return []; };
        NgxuiDatatableComponent.propDecorators = {
            config: [{ type: core.Input }],
            data: [{ type: core.Input }],
            templates: [{ type: core.Input }],
            actions: [{ type: core.Input }],
            clickEvent: [{ type: core.Output }]
        };
        return NgxuiDatatableComponent;
    }());
    if (false) {
        /** @type {?} */
        NgxuiDatatableComponent.prototype.config;
        /** @type {?} */
        NgxuiDatatableComponent.prototype.data;
        /** @type {?} */
        NgxuiDatatableComponent.prototype.templates;
        /** @type {?} */
        NgxuiDatatableComponent.prototype.actions;
        /** @type {?} */
        NgxuiDatatableComponent.prototype.clickEvent;
        /** @type {?} */
        NgxuiDatatableComponent.prototype.order;
        /** @type {?} */
        NgxuiDatatableComponent.prototype.currentSortKey;
        /** @type {?} */
        NgxuiDatatableComponent.prototype.context;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TableHeaderComponent = /** @class */ (function () {
        function TableHeaderComponent() {
            this.emitSortClick = new core.EventEmitter();
            this.toggled = false;
        }
        /**
         * @return {?}
         */
        TableHeaderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @param {?} name
         * @return {?}
         */
        TableHeaderComponent.prototype.clickHeader = /**
         * @param {?} name
         * @return {?}
         */
        function (name) {
            this.toggled = !this.toggled;
            this.emitSortClick.emit(name);
        };
        /**
         * @return {?}
         */
        TableHeaderComponent.prototype.issort = /**
         * @return {?}
         */
        function () {
            return this.toggled && this.name === this.sortKey;
        };
        TableHeaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-table-header',
                        template: "<div class=\"ngxui-datatable__th\" (click)=\"clickHeader(name)\" [class.ngxui-datatable--active]=\"issort()\">\n    <span>{{ name }}</span>\n</div>\n",
                        styles: [":host{text-align:-internal-center;display:table-cell;vertical-align:inherit;font-weight:700}:host--active{-webkit-transform:rotate(180deg);transform:rotate(180deg)}"]
                    }] }
        ];
        /** @nocollapse */
        TableHeaderComponent.ctorParameters = function () { return []; };
        TableHeaderComponent.propDecorators = {
            name: [{ type: core.Input }],
            sortKey: [{ type: core.Input }],
            emitSortClick: [{ type: core.Output }]
        };
        return TableHeaderComponent;
    }());
    if (false) {
        /** @type {?} */
        TableHeaderComponent.prototype.name;
        /** @type {?} */
        TableHeaderComponent.prototype.sortKey;
        /** @type {?} */
        TableHeaderComponent.prototype.emitSortClick;
        /** @type {?} */
        TableHeaderComponent.prototype.toggled;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxuiDatatableModule = /** @class */ (function () {
        function NgxuiDatatableModule() {
        }
        NgxuiDatatableModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [NgxuiDatatableComponent, TableHeaderComponent],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [NgxuiDatatableComponent]
                    },] }
        ];
        return NgxuiDatatableModule;
    }());

    exports.NgxuiDatatableComponent = NgxuiDatatableComponent;
    exports.NgxuiDatatableModule = NgxuiDatatableModule;
    exports.NgxuiDatatableService = NgxuiDatatableService;
    exports.ɵa = TableHeaderComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngxui-datatable.umd.js.map
